#pragma GCC optimize("O3")

#include <bits/stdc++.h>

using namespace std;

#define ll long long
#define lf long double
#define all(vec) vec.begin(), vec.end()
#define rall(vec) vec.rbegin(), vec.rend()
#define nl "\n"
#define chmyax(a, b) a = max(a, b)
#define chmyin(a, b) a = min(a, b)

const ll LOG = 20;

vector<vector<ll>> adj;
vector<ll> tin;
vector<ll> tout;
vector<ll> dist;
vector<vector<ll>> up;
ll timer = 0;

void dfs(ll v, ll p) {
  tin[v] = timer++;
  up[v][0] = p;
  dist[v] = dist[p] + 1;
  for (ll i = 1; i < LOG; i++) {
    up[v][i] = up[up[v][i - 1]][i - 1];
  }
  for (ll i : adj[v]) {
    if (i == p)
      continue;
    dfs(i, v);
  }
  tout[v] = timer++;
}

bool is_ancestor(ll a, ll b) { return tin[a] <= tin[b] && tout[a] >= tout[b]; }

ll lca(ll a, ll b) {
  if (is_ancestor(a, b))
    return a;
  if (is_ancestor(b, a))
    return b;
  for (ll i = LOG - 1; i >= 0; i--) {
    if (!is_ancestor(up[a][i], b))
      a = up[a][i];
  }
  return up[a][0];
}

ll up_n(ll a, ll n) {
  for (ll i = LOG - 1; i >= 0; i--) {
    if (n >> i & 1)
      a = up[a][i];
  }
  return a;
}

const ll MOD = 1e9 + 7;

ll binpow(ll n, ll k) {
  if (k == 0)
    return 1;
  if (k == 1)
    return n;
  ll res = k & 1 ? n : 1;
  ll tmp = binpow(n, k >> 1);
  return (((res * tmp) % MOD) * tmp) % MOD;
}

vector<ll> dsu_par;
vector<ll> dsu_sz;

ll get(ll a) {
  if (a == dsu_par[a])
    return a;
  return dsu_par[a] = get(dsu_par[a]);
}

void merge(ll a, ll b) {
  a = get(a);
  b = get(b);
  if (a == b) {
    return;
  }
  if (dsu_sz[a] < b)
    swap(a, b);
  dsu_par[b] = a;
  dsu_sz[a] += dsu_sz[b];
}

/*vector<vector<ll>> opening;
vector<vector<ll>> closing;

ll curr_opened_cnt = 0;
ll curr_seg = -1;

void dfs2(ll v, ll p) {
  if (!opening[v].empty()) {
    if (curr_seg == -1) {
      curr_opened_cnt++;
      curr_seg = opening[v].back();
      opening[v].pop_back();
    }
    for (ll i : opening[v]) {
      curr_opened_cnt++;
      merge(curr_seg, i);
    }
    opening[v].clear();
  }
}*/

int main() {
  ios_base::sync_with_stdio(0);
  cin.tie(0);
  cout.tie(0);
  // freopen("in", "r", stdin);
  ll a, b, c, d, f;
  ll n, m, k;
  string str;
  char ch;
  cin >> n >> m;
  cout<<0;
}
