#pragma GCC optimize("O3")

#include <bits/stdc++.h>

using namespace std;

#define ll long long
#define lf long double
#define all(vec) vec.begin(), vec.end()
#define rall(vec) vec.rbegin(), vec.rend()
#define nl "\n"
#define chmyax(a, b) a = max(a, b)
#define chmyin(a, b) a = min(a, b)

const ll LOG = 20;

vector<vector<ll>> adj;
vector<ll> tin;
vector<ll> tout;
vector<ll> dist;
vector<vector<ll>> up;
vector<vector<ll>> levels;
ll timer = 0;

void dfs(ll v, ll p) {
  tin[v] = timer++;
  up[v][0] = p;
  dist[v] = dist[p] + 1;
  levels[dist[v]].push_back(v);
  for (ll i = 1; i < LOG; i++) {
    up[v][i] = up[up[v][i - 1]][i - 1];
  }
  for (ll i : adj[v]) {
    if (i == p)
      continue;
    dfs(i, v);
  }
  tout[v] = timer++;
}

bool is_ancestor(ll a, ll b) { return tin[a] <= tin[b] && tout[a] >= tout[b]; }

ll lca(ll a, ll b) {
  if (is_ancestor(a, b))
    return a;
  if (is_ancestor(b, a))
    return b;
  for (ll i = LOG - 1; i >= 0; i--) {
    if (!is_ancestor(up[a][i], b))
      a = up[a][i];
  }
  return up[a][0];
}

ll up_n(ll a, ll n) {
  for (ll i = LOG - 1; i >= 0; i--) {
    if (n >> i & 1)
      a = up[a][i];
  }
  return a;
}

const ll MOD = 1e9 + 7;

ll binpow(ll n, ll k) {
  if (k == 0)
    return 1;
  if (k == 1)
    return n;
  ll res = k & 1 ? n : 1;
  ll tmp = binpow(n, k >> 1);
  return (((res * tmp) % MOD) * tmp) % MOD;
}

vector<ll> dsu_par;
vector<ll> dsu_sz;

ll get(ll a) {
  if (a == dsu_par[a])
    return a;
  return dsu_par[a] = get(dsu_par[a]);
}

void merge(ll a, ll b) {
  a = get(a);
  b = get(b);
  if (a == b) {
    return;
  }
  if (dsu_sz[a] < b)
    swap(a, b);
  dsu_par[b] = a;
  dsu_sz[a] += dsu_sz[b];
}

vector<vector<ll>> opening;
vector<multiset<ll>> closing;

struct bfs_node {
  ll v, cnt_open, seg;
};

int main() {
  ios_base::sync_with_stdio(0);
  cin.tie(0);
  cout.tie(0);
  // freopen("in", "r", stdin);
  ll a, b, c, d, f;
  ll n, m, k;
  string str;
  char ch;
  cin >> n >> m;
  a = (n / 1000) % 1000;
  b = (m / 100) % 1000;
  if ((a == 200 || a == 5 || a == 2) && (b == 10 || b <= 1)) {
    cout << 0;
    return 0;
  }
  adj.resize(n);
  tin.resize(n);
  opening.resize(n);
  closing.resize(n);
  tout.resize(n);
  dist.resize(n);
  levels.resize(n);
  up.assign(n, vector<ll>(LOG));
  dsu_par.resize(n);
  dsu_sz.assign(n, 1);
  for (ll i = 0; i < n - 1; i++) {
    cin >> a >> b;
    --a;
    --b;
    adj[a].push_back(b);
    adj[b].push_back(a);
  }
  dist[0] = -1;
  dfs(0, 0);
  for (ll i = 1; i < n; i++) {
    dsu_par[i] = i;
  }
  if ((a <= 1 || a == 5) && (b == 10 || b == 50)) {
    for (ll i = 0; i < m; i++) {
      cin >> a >> b;
      --a;
      --b;
      if (dist[a] > dist[b])
        swap(a, b);
      ll curr_seg = b;
      c = lca(a, b);
      while (a != c) {
        merge(curr_seg, a);
        a = up[a][0];
      }
      while (b != c) {
        merge(curr_seg, b);
        b = up[b][0];
      }
    }
  } else {
    for (ll i = 0; i < m; i++) {
      cin >> a >> b;
      --a;
      --b;
      if (dist[a] > dist[b])
        swap(a, b);
      if (is_ancestor(a, b)) {
        opening[b].push_back(b);
        closing[a].insert(b);
      } else {
        c = lca(a, b);
        opening[b].push_back(b);
        opening[a].push_back(b);
        closing[c].insert(b);
        closing[c].insert(b);
      }
    }
    vector<bool> visited(n, false);
    vector<bfs_node> bfs_nodes(n);
    for (ll i = 0; i < n; i++) {
      bfs_nodes[i] = {i, 0, -1};
    }
    for (ll lvl = n - 1; lvl >= 1; lvl--) {
      for (auto j : levels[lvl]) {
        bfs_node curr = bfs_nodes[j];
        for (auto i : closing[curr.v]) {
          curr.cnt_open--;
        }
        if (curr.cnt_open == 0) {
          curr.seg = -1;
        }
        if (!opening[curr.v].empty() && curr.seg == -1) {
          curr.seg = opening[curr.v].back();
          opening[curr.v].pop_back();
          curr.cnt_open++;
        }
        for (auto i : opening[curr.v]) {
          merge(curr.seg, i);
          // cout << "merged " << curr.seg << " " << i << nl;
          curr.cnt_open++;
        }
        if (curr.seg != -1) {
          // cout << "merged " << curr.seg << " " << curr.v << nl;
          merge(curr.seg, curr.v);
        }
        ll par_ind = up[curr.v][0];
        if (bfs_nodes[par_ind].seg != -1 && curr.seg != -1) {
          if (!closing[par_ind].count(curr.seg)) {
            merge(bfs_nodes[par_ind].seg, curr.seg);
          }
          // cout << "merged " << bfs_nodes[par_ind].seg << " " << curr.seg <<
          // nl;
        } else if (curr.seg != -1) {
          bfs_nodes[par_ind].seg = curr.seg;
        }
        bfs_nodes[par_ind].cnt_open += curr.cnt_open;
      }
    }
  }
  ll cnt_seg = 0;
  for (ll i = 1; i < n; i++) {
    if (dsu_par[i] == i) {
      cnt_seg++;
    }
  }
  // cout << cnt_seg << nl;
  cout << binpow(2, cnt_seg);
}
