#pragma GCC optimize("O3")

#include <bits/stdc++.h>

using namespace std;

#define ll long long
#define lf long double
#define all(vec) vec.begin(), vec.end()
#define rall(vec) vec.rbegin(), vec.rend()
#define nl "\n"
#define chmyax(a, b) a = max(a, b)
#define chmyin(a, b) a = min(a, b)

struct SegmentTree {
  vector<ll> vertices;
  ll N;
  void build(vector<ll> &arr) {
    N = arr.size();
    vertices.resize(4 * N);
    _build(1, 0, N - 1, arr);
  }
  void _build(ll v, ll l, ll r, vector<ll> &arr) {
    if (l == r) {
      vertices[v] = arr[l];
      return;
    }
    ll m = (l + r) / 2;
    _build(v * 2, l, m, arr);
    _build(v * 2 + 1, m + 1, r, arr);
    vertices[v] = gcd(vertices[v * 2], vertices[v * 2 + 1]);
  }
  void update(ll ind, ll val) { _update(1, 0, N - 1, ind, val); }
  void _update(ll v, ll l, ll r, ll ind, ll val) {
    if (l == r) {
      vertices[v] = val;
      return;
    }
    ll m = (l + r) / 2;
    if (ind <= m) {
      _update(v * 2, l, m, ind, val);
    } else {
      _update(v * 2 + 1, m + 1, r, ind, val);
    }
    vertices[v] = gcd(vertices[v * 2], vertices[v * 2 + 1]);
  }
  ll get(ll ql, ll qr) { return _get(1, 0, N - 1, ql, qr); }
  ll _get(ll v, ll l, ll r, ll ql, ll qr) {
    if (ql > qr) {
      return 0;
    }
    if (l == ql && r == qr) {
      return vertices[v];
    }
    ll m = (l + r) / 2;
    return gcd(_get(v * 2, l, m, ql, min(qr, m)),
               _get(v * 2 + 1, m + 1, r, max(ql, m + 1), qr));
  }
};

int main() {
  ios_base::sync_with_stdio(0);
  cin.tie(0);
  cout.tie(0);
  // freopen("in", "r", stdin);
  ll a, b, c, d, f;
  ll n, m, k;
  string str;
  char ch;
  ll q, l, r;
  cin >> n >> q;
  vector<ll> arr(n);
  for (ll i = 0; i < n; i++) {
    cin >> arr[i];
  }
  SegmentTree st;
  st.build(arr);
  while (q--) {
    cin >> a >> b >> c;
    --b;
    if (a == 1) {
      arr[b] = c;
      st.update(b, c);
    } else {
      --c;
      ll ans = 0;
      for (ll i = b; i <= c; i++) {
        if (c - i < 10000) {
          d = 0;
          for (ll j = i; j <= c; j++) {
            d = gcd(d, arr[j]);
            if (d > 1)
              ans++;
            else
              break;
          }
          continue;
        }
        if (arr[i] == 1)
          continue;
        l = i;
        r = c + 1;
        while (r - l > 1) {
          ll m = (l + r) / 2;
          if (st.get(i, m) != 1) {
            l = m;
          } else {
            r = m;
          }
        }
        ans += r - i;
      }
      cout << ans << nl;
    }
  }
}
