#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <algorithm>

using namespace std;
using ll = long long;
using ld = long double;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int buildings_count;
    ll target_coins;

    cin >> buildings_count >> target_coins;

    vector<ll> heights(buildings_count);
    vector<ll> coins(buildings_count);

    for (int i = 0; i < buildings_count; i++) {
        cin >> heights[i] >> coins[i];
    }

    vector<map<ll, ll>> ways_to_pass(buildings_count);
    ll result = 0;

    int middle = buildings_count / 2;

    for (int start_building = buildings_count - 1; start_building >= middle; start_building--) {
        ways_to_pass[start_building][coins[start_building]] = 1;

        for (int next_building = start_building + 1; next_building < buildings_count; next_building++) {
            if (heights[next_building] >= heights[start_building]) {
                for (auto [next_coins, next_ways] : ways_to_pass[next_building]) {
                    ways_to_pass[start_building][next_coins + coins[start_building]] += next_ways;
                }
            }
        }

        for (auto [start_coins, start_ways] : ways_to_pass[start_building]) {
            if (start_coins >= target_coins) {
                result += start_ways;
            }
        }
    }

    vector<map<ll, ll>> ways_to_pass2(buildings_count);

    for (int i = 0; i < middle; i++) {
        ways_to_pass2[i][coins[i]] = 1;

        for (int j = 0; j < i; j++) {
            if (heights[j] <= heights[i]) {
                for (auto [next_coins, next_ways] : ways_to_pass2[j]) {
                    ways_to_pass2[i][next_coins + coins[i]] += next_ways;
                }
            }
        }

        for (auto [start_coins, start_ways] : ways_to_pass2[i]) {
            if (start_coins >= target_coins) {
                result += start_ways;
            }
        }
    }

    for (int i = 0; i < middle; i++) {
        for (int j = middle; j < buildings_count; j++) {
            if (heights[i] > heights[j]) {
                continue;
            }

            ll sum = 0;

            for (auto iter = ways_to_pass[j].rbegin(); iter != ways_to_pass[j].rend(); iter++) {
                sum += iter->second;

                for (auto [start_coins, start_ways] : ways_to_pass2[i]) {
                    if (start_coins + iter->first >= target_coins) {
                        result += sum * start_ways;
                    }
                }
            }
        }
    }

    cout << result << "\n";

    return 0;
}