#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <algorithm>

using namespace std;
using ll = long long;
using ld = long double;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int n;
    ll k;

    cin >> n >> k;

    vector<ll> heights(n);
    vector<ll> coins(n);

    for (int i = 0; i < n; i++) {
        cin >> heights[i] >> coins[i];
    }

    int middle = n / 2;
    ll result = 0;

    vector<map<ll, ll>> start_paths(n);

    for (int i = 0; i < middle; i++) {
        start_paths[i][coins[i]] += 1;

        for (int j = 0; j < i; j++) {
            if (heights[j] <= heights[i]) {
                for (auto [prev_coins, prev_ways] : start_paths[j]) {
                    start_paths[i][prev_coins + coins[i]] += prev_ways;
                }
            }
        }
        
        for (auto [coins, ways] : start_paths[i]) {
            if (coins >= k) {
                result += ways;
            }
        }
    }

    vector<map<ll, ll>> end_paths(n);

    for (int i = n - 1; i >= middle; i--) {
        end_paths[i][coins[i]] += 1;

        for (int j = i + 1; j < n; j++) {
            if (heights[j] >= heights[i]) {
                for (auto [next_coins, next_ways] : end_paths[j]) {
                    end_paths[i][next_coins + coins[i]] += next_ways;
                }
            }
        }

        for (auto [coins, ways] : end_paths[i]) {
            if (coins >= k) {
                result += ways;
            }
        }
    }

    for (int i = 0; i < middle; i++) {
        for (int j = middle; j < n; j++) {
            if (heights[i] > heights[j]) {
                continue;
            }

            ll sum = 0;
            bool step_iter2 = true;
            auto iter2 = end_paths[j].end();

            for (auto iter = start_paths[i].begin(); iter != start_paths[i].end(); iter++) {
                while (step_iter2 && iter->first + prev(iter2)->first >= k) {
                    iter2--;
                    sum += iter2->second;

                    if (iter2 == end_paths[j].begin()) {
                        step_iter2 = false;
                        break;
                    }
                }

                result += sum * iter->second;
            }
        }
    }

    cout << result << "\n";

    return 0;
}
