#include <bits/stdc++.h>
using namespace std;

const int DIM = 1e5;

pair<int, string> words[DIM];
int q_words;

bool comp(pair<int, string>& A, pair<int, string>& B){
    return A.first < B.first || (A.first == B.first && A.second < B.second);
}

struct Heap{
    int start_ind, end_ind, len;

    Heap(int start, int end){
        start_ind = start;
        end_ind = end;
        len = end_ind - start_ind;
    }
    Heap(){}

    void set_heap(int start, int end){
        start_ind = start;
        end_ind = end;
        len = end_ind - start_ind;
    }

    int get_ind(int ind){
        return start_ind + ind - 1;
    }
    pair<int,string>& get(int ind){
        return words[get_ind(ind)];
    }
    bool is_in_heap(int ind){
        return get_ind(ind) < end_ind;
    }

    void heapify(int root){
        int max_son = 2 * root;
        if (!is_in_heap(max_son)) return;

        if (comp(get(max_son + 1), get(max_son)) && is_in_heap(max_son + 1))
            ++max_son;
        
        if (comp(get(max_son), get(root))){
            swap(get(max_son), get(root));
            heapify(max_son);
        }
    }

    void make_heap(){
        for (int i = len/2; i > 0; --i)
            heapify(i);
    }
} heaps[26];

void make_heaps(){
    int last_heap_end = 0;
    for (int i = 1; i < q_words; ++i)
        if (words[last_heap_end].second[0] != words[i].second[0]){
            heaps[words[last_heap_end].second[0] - 'a'].set_heap(last_heap_end, i);
            last_heap_end = i;
        }
    heaps[words[last_heap_end].second[0] - 'a'].set_heap(last_heap_end, q_words);

    for (int i = 0; i < 26; ++i)
        heaps[i].make_heap();
}

void input_words(){
    for (int i = 0; i < q_words; ++i){
        cin >> words[i].second;
        words[i].first = 0;
    }
    sort(words, words + q_words, comp);

    make_heaps();
}


void output_words(){
    for (pair<int, string> word : words)
        cout << word.second << ' ';
    cout << '\n';      
}


int main() {
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);

    int q_chars; cin >> q_words >> q_chars; input_words();

    char c; pair<int, string> word;
    for (int i = 0; i < q_chars; ++i){
        cin >> c;
        cout << heaps[c - 'a'].get(1).second << '\n';

        ++heaps[c - 'a'].get(1).first;
        heaps[c - 'a'].heapify(1);

        //output_words();
    }

    return 0;
}
