#include <bits/stdc++.h>
using namespace std;

const int DIM = 40;
struct House{
    int height, gold;
} skyscapers[DIM];
vector<long long> ways[40];

int q_houses;

void input_houses(){
    for (int i = 0; i < q_houses; ++i)
        cin >> skyscapers[i].height >> skyscapers[i].gold; 
}

void insert_sorted(long long way, int ind){
    int left = 0, right = ways[ind].size(), mid;

    while (left < right){
        mid = (left + right) >> 1;
        if (way > ways[ind][mid])
            left = mid + 1;
        else
            right = mid;
    }

    ways[ind].insert(ways[ind].begin() + left, way);
    if (ways[ind].size() >= 11000)
        ways[ind].erase(ways[ind].end() - 1);
}

int lower_bound(int ind, long long min_gold_needed){
    int left = 0, right = ways[ind].size(), mid;

    while (left < right){
        mid = (left + right) >> 1;
        if (min_gold_needed > ways[ind][mid])
            left = mid + 1;
        else
            right = mid;
    }

    return left;
}

void output_ways(){
    for (int i = 0; i < q_houses; ++i){
        for (long long way : ways[i])
            cout << way << ' ';
        cout << '\n';
    }
}

int main() {
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);

    long long min_gold_needed; cin >> q_houses >> min_gold_needed; input_houses();

    for (int i = 0; i < q_houses; ++i){
        insert_sorted(skyscapers[i].gold, i);
        for (int j = 0; j < i; ++j)
            if (skyscapers[j].height <= skyscapers[i].height)
                for (long long way : ways[j])
                    insert_sorted(way + skyscapers[i].gold, i);
    }

    long long q_ways = 0;
    for (int i = 0; i < q_houses; ++i){
        q_ways += ways[i].size() - lower_bound(i, min_gold_needed);
    }

    cout << q_ways << '\n';
    //output_ways();

    return 0;    
}
