#include <bits/stdc++.h>
using namespace std;

const int DIM = 3e5;
const long long mod = 1e9 + 7;

vector<int> ribs[DIM];
pair<int, int> segm[DIM];
int q_vert, q_segm;

bool comp(pair<int, int>& A, pair<int, int>& B){
    return A.first < B.first;
}

void input_ribs_and_segm(){
    cin >> q_vert >> q_segm;
    for (int i = 0, v, u; i < q_vert-1; ++i){
        cin >> v >> u; --v; --u;
        ribs[v].push_back(u);
        ribs[u].push_back(v);
    }
    for (int i = 0, a, b; i < q_segm; ++i){
        cin >> a >> b; --a; --b;
        if (a > b) swap(a, b);
        segm[i] = {a, b};
    }
}

long long pow_mod(long long a, long long pow){
    long long res = a; --pow;

    while (pow > 0){
        if (pow % 2 != 0)
            res = (res * a) % mod;
        a = (a * a) % mod;
        pow /= 2;
    }

    return res;
}

int main() {
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);

    input_ribs_and_segm();
    sort(segm, segm + q_segm, comp);

    int q_not_covered = segm[0].first, q_intersects = 1;
    int last_end = segm[0].second;
    for (int i = 1; i < q_segm; ++i){
        if (last_end > segm[i].first)
            last_end = max(segm[i].second, last_end);
        else {
            q_not_covered += segm[i].first - last_end;
            ++q_intersects;
            last_end = segm[i].second;
        }
    }
    q_not_covered += q_vert - last_end - 1;

    cout << pow_mod(2, q_not_covered + q_intersects) << '\n';

    return 0;
}
