#include <bits/stdc++.h>
using namespace std;

// final speedup goals/opportunities:
// - optimized нсд algorithm
// - not recalculating everything after each query

// maybe we don't need to calculate the нсд but rather predict
// whether it's going to be bigger than 1
// for example, it will always be 1 if there is a 1 in an array
//                      always be 1 if there are multiple prime numbers
//                      always be the first number if all numbers are the same

// examples of arrays where найбільший спільний дільник == 1:
// 1 1 1 1 1 1 1
// 1 3 45 6 14 6
// 2 3 5 7 11
// 2 3 4 6
// 2 13 

// Note: this is loose and approximate (to optimize performance)
int isPrime(int num) {
    if (num <= 3) { return 1; }
    if (num % 2 == 0) { return 0; }
    if (num > 2000) { return 0; } // remove this for the function to be 100% accurate
    for (int i = 3; i<num; i++) {
        if (num % i == 0) { return 0; }
    }
    return 1;
}


int nsdForTwo(int a, int b) {
    while (b >= 1) {
        int holder = b;
        b = a % b;
        a = holder;
    }
    return a;
}

int nsdForArray(int* arr, int count) {
    if (count < 2) {
        return arr[0];
    }
    if (count == 2) {
        return nsdForTwo(arr[0], arr[1]);
    }
    int lastResult = nsdForTwo(arr[0], arr[1]);
    for (int i = 2; i<count; i++) {
        lastResult = nsdForTwo(lastResult, arr[i]);
        if (lastResult == 1) {
            return lastResult;
        }
    }
    return lastResult;
}


int getNsd(int* arr, int l, int r) {
    // todo: optimizations for one-number and two-number arrays
    int firstNum = arr[l];
    int allsame = 1;
    int lastPrime = 0;
    for (int i = l; i<=r; i++) {
        int numHere = arr[i];
        // is there a 1 in the array?
        if (numHere == 1) { return 1; }

        allsame = allsame & numHere == firstNum;
        if (isPrime(numHere)) {
            // two prime numbers?
            if (lastPrime != 0 && lastPrime != numHere) {
                return 1;
            }
            lastPrime = numHere;
        }
    }
    // are all of them the same?
    if (allsame) {return firstNum;}
    return nsdForArray(arr+l, r-l+1);
}

// Nooooooo this very very very VERY bad
void calculateAllInterestInArray(int* arr, int count, int* interestings) {
    for (int size = 2; size<=count; size++) {
        for (int i = 0; i < count - size + 1; i++) {
            //cout << "trying " << i << ' ' << i + size - 1 << endl;
            int nsd = getNsd(arr + i, 0, size - 1);
            *interestings += (nsd != 1);
        }
    }
}

// what if a prime number is at the beginning/end?
// note: handles duplicate prime numbers very weirdly

// THIS FUNCTION IS VERY VERY BROKEN PLEASE FIX
// IT SOMETIMES SKIPS VERY IMPORTANT SEGMENTS AT THE END
// AND MAYBE AT THE BEGINNING I DONT KNOW I DIDNT TEST
// ^^^^^^^^ fix this!!!!! for correctie !!!!!
void breakDownArrayByPrime(int* arr, int count, int* interestings) {
    int lastPrime = 0;
    int lastPrimeIdx = 0;
    int beforeLastPrimeIdx = 0;
    int lastSplitRIdx = -1;
    for (int i = 0; i<count; i++) {
        int thisNum = arr[i];
        int thisPrime = isPrime(thisNum);
        //cout << thisNum << ' ' << thisPrime << endl;
        if (thisPrime && thisNum != lastPrime) {
            if (lastPrime != 0) {
                // splitting logic
                int splitL = beforeLastPrimeIdx;
                int splitR = i - 1;
                
                lastSplitRIdx = lastPrimeIdx;
                i = lastPrimeIdx;
                beforeLastPrimeIdx = lastPrimeIdx + 1;
                lastPrimeIdx = 0;
                lastPrime = 0;
                // now we kinda need to split further by the number 1
                // because 1 will always bring the biggest div down
                int lastOneIdx = splitL - 1;
                for (int innerI = splitL; innerI<=splitR; innerI++) {
                    int numInside = arr[innerI];
                    if (numInside == 1) {
                        if (lastOneIdx + 1 != innerI - 1) {
                            //cout << "split1: " << lastOneIdx + 1 << ' ' << innerI - 1 << endl;
                            calculateAllInterestInArray(arr + lastOneIdx + 1, innerI - 1 - lastOneIdx, interestings);
                        }
                        lastOneIdx = innerI;
                    }
                }
                if (lastOneIdx + 1 != splitR) {
                    //cout << "split2: " << lastOneIdx + 1 << ' ' << splitR << endl;
                    // note: did i change this right
                    calculateAllInterestInArray(arr + lastOneIdx + 1, splitR - lastOneIdx, interestings);
                }
            } else {
                lastPrime = thisNum;
                lastPrimeIdx = i;
            }
        }
    }
    if (lastSplitRIdx + 1 != count - 1) {
        //cout << "split3: " << lastSplitRIdx + 1 << ' ' << count - 1 << endl;
        calculateAllInterestInArray(arr + lastSplitRIdx + 1, count - 1 - lastSplitRIdx, interestings);
    }
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n, q;
    cin>>n>>q;
    int* a = (int*)malloc(n*sizeof(int));
    for (int i = 0; i<n; i++) {
        int numHere;
        cin >> numHere;
        a[i] = numHere;
    }
    for (int i = 0; i<q; i++) {
        int queryKind;
        cin >> queryKind;
        if (queryKind == 1) {
            int x, v;
            cin >> x >> v;
            a[x-1] = v;
        } else {
            // remember to reduce the l and r bounds by 1!
            int l, r;
            cin>>l>>r;
            l--;
            r--;
            // optimization: check numbers individually first so the future thing does not have to do it
            int interestings = 0;
            for (int x = l; x <= r; x++) {
                int num = a[x];
                interestings += (num != 1);
            }
            // The good and innocent and optimized variant
            // breakDownArrayByPrime(a+l, (r-l)+1, &interestings);

            // Grrr brute force monstrosity but probably very accurate
            calculateAllInterestInArray(a+l, (r-l)+1, &interestings);

            cout << interestings << endl;
            // array optimization ideas:
            // - split arrays by 1
            // - if two prime numbers exist, break down further into 3 pieces
        }
    }
}
