#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <algorithm>
#include <vector>
#include <math.h>
#include <random>
#include <iomanip>
#include <stack>
#include <set>
#include <map>
#include <queue>
#include <numeric>

using namespace std;

#define LF '\n';
typedef long long lli;
typedef long double ld;

const lli MOD = 1e9 + 7;

vector<vector<lli>> g;
vector<lli> p;
vector<lli> d;
vector<lli> tin;
vector<lli> tout;



struct DSU
{
    vector<lli> boss;
    vector<lli> sz;

    void init(lli n) {
        boss.resize(n + 1);
        sz.resize(n + 1,1);
        for (int i = 1; i <= n; i++)boss[i] = i;
    }

    lli get(lli a) {
        if (boss[a] == a)return a;
        return boss[a] = get(boss[a]);
    }

    void merge(lli u1, lli u2) {
        lli b1 = get(u1);
        lli b2 = get(u2);
        if (sz[b1] < sz[b2])swap(b1,b2);
        sz[b1] += sz[b2];
        boss[b2] = b1;
    }

    bool check(lli u1, lli u2) {
        return get(u1) == get(u2);
    }

    lli ans(lli n) {
        lli res = 0;
        for (int i = 2; i <= n; i++)if (boss[i] == i)res++;
        return res;
    }

}dsu;


struct LCA
{
    const lli K = 20;
    vector<vector<lli>> arr;
    lli tt;

    void dfs(lli a, lli pp,lli dd) {
        p[a] = pp;
        d[a] = dd;
        tin[a] = tt++;
        for (auto to : g[a])if(to!=pp)dfs(to, a,dd+1);
        tout[a] = tt++;
    }

    void init(lli n) {
        p.resize(n + 1);
        d.resize(n + 1);
        tin.resize(n + 1);
        tout.resize(n + 1);
        tt = 0;
        dfs(1, 0,0);
        arr.resize(n+1);
        for (int i = 0; i <= n; i++) {
            arr[i].resize(K);
            arr[i][0] = p[i];
        }
        for (int b = 1; b < K; b++)for (int i = 1; i <= n; i++)arr[i][b] = arr[arr[i][b - 1]][b - 1];
    }

    bool check(lli u1, lli u2) {
        if (u1 == 0)return 1;
        if (tin[u1] <= tin[u2] && tout[u1] >= tout[u2])return 1;
        return 0;
    }

    lli get(lli u1, lli u2) {
        for (int i = K - 1; i >= 0; i--) {
            lli curr = arr[u1][i];
            if (!check(curr, u2))u1=curr;
        }
        if (check(u1, u2))return u1;
        else return p[u1];
    }

    lli get2(lli u1, lli u2) {
        if (u1 == u2)return 0;
        for (int i = K - 1; i >= 0; i--) {
            lli curr = arr[u1][i];
            if (!check(curr, u2))u1 = curr;
        }
        return u1;
    }

}lca;

lli pw(lli a, lli b) {
    lli res = 1;
    while (b) {
        if (b % 2)res = (res * a) % MOD;
        a = (a * a) % MOD;
        b /= 2;
    }
    return res;
}

void solve()
{
    lli n,m;
    cin >> n >> m;
    g.resize(n + 1);
    for (int i = 1; i < n; i++) {
        lli u1, u2;
        cin >> u1 >> u2;
        g[u1].push_back(u2);
        g[u2].push_back(u1);
    }
    dsu.init(n);
    lca.init(n);
    for (int i = 1; i <= m; i++) {
        lli u1, u2;
        cin >> u1 >> u2;
        lli u3 = lca.get(u1, u2);
        lli pr = -1;
        while (u1 != u3 && p[u1]!=0) {
            if (pr != -1) {
      //          if (dsu.check(pr, u1 - 1))break;
                dsu.merge(pr, u1);
            }
            pr = u1;
            u1 = p[u1];
        }
    //    pr = lca.get2(u1, u3)-1;
        while (u2 != u3 && p[u2] != 0) {
            if (pr != -1) dsu.merge(pr, u2);
            pr = u2;
            u2 = p[u2];
        }
    }

    cout << pw(2,dsu.ans(n));
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
#ifdef _DEBUG
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif 

    solve();
}

