#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <algorithm>
#include <vector>
#include <math.h>
#include <random>
#include <iomanip>
#include <stack>
#include <set>
#include <map>
#include <queue>
#include <numeric>
#include <unordered_map>

using namespace std;

#define LF '\n';
typedef long long lli;
typedef long double ld;

vector<lli> v;

struct SUPER_SIGMAK_TREE
{
    struct node {
        vector<pair<lli,lli>> pref;
        vector<pair<lli, lli>> suff;
        lli ans;
        lli g;
    };

    vector<node> t;
    lli n;

    node merge(node n1, node n2) {
        node res;
        unordered_map<lli, lli> mp;
        for (auto to : n1.pref)mp[to.first] += to.second;
        for (auto to : n2.pref)mp[gcd(n1.g, to.first)] += to.second;
        for (auto to : mp)if (to.first != 1)res.pref.push_back(to);
        mp.clear();

        for (auto to : n2.suff)mp[to.first] += to.second;
        for (auto to : n1.suff)mp[gcd(n2.g, to.first)] += to.second;
        for (auto to : mp)if (to.first != 1)res.suff.push_back(to);

        res.ans = n1.ans + n2.ans;
        for (auto to1 : n1.suff)for (auto to2 : n2.pref)if (gcd(to1.first, to2.first) != 1)res.ans += to1.second * to2.second;
        res.g = gcd(n1.g, n2.g);
        return res;
    }

    void build(lli a, lli l, lli r) {
        if (l == r) {
            t[a].pref.push_back({ v[l],1 });
            t[a].suff.push_back({ v[l],1 });
            t[a].g = v[l];
            if (v[l] != 1)t[a].ans = 1;
            return;
        }
        lli m = (l + r) >> 1;
        build(a * 2 + 1, l, m);
        build(a * 2 + 2, m+1, r);
        t[a] = merge(t[a * 2 + 1], t[a * 2 + 2]);
    }

    void init(lli nn) {
        n = nn;
        t.resize(4 * n);
        build(0, 1, n);
    }

    node get(lli a, lli tl, lli tr, lli l, lli r){
        if (tl > r || tr < l)return { {},{},0,0 };
        if (tl >= l && tr <= r)return t[a];
        lli tm = (tl + tr) >> 1;
        return merge(get(a * 2 + 1, tl, tm, l, r), get(a * 2 + 2, tm + 1, tr, l, r));
    }

    lli get_range(lli l, lli r) {
        return get(0, 1, n, l, r).ans;
    }

    void upd(lli a, lli l, lli r, lli ind) {
        if (r<ind || l>ind)return;
        if (l == r) {
            t[a].pref.clear();
            t[a].suff.clear();
            t[a].pref.push_back({ v[l],1 });
            t[a].suff.push_back({ v[l],1 });
            t[a].g = v[l];
            t[a].ans = 0;
            if (v[l] != 1)t[a].ans = 1;
            return;
        }
        lli m = (l + r) >> 1;
        upd(a * 2 + 1, l, m,ind);
        upd(a * 2 + 2, m + 1, r,ind);
        t[a] = merge(t[a * 2 + 1], t[a * 2 + 2]);
    }

    void update(lli ind){
        upd(0, 1, n, ind);
    }

}st;

void solve()
{
    lli n, q;
    cin >> n >> q;
    v.resize(n + 1);
    for (int i = 1; i <= n; i++)cin >> v[i];
    st.init(n);
    for (int i=1;i<=q;i++){
        lli type;
        cin >> type;
        if (type == 2) {
            lli l, r;
            cin >> l >> r;
            cout << st.get_range(l, r) << LF;
        }
        else {
            lli ind, val;
            cin >> ind >> val;
            v[ind] = val;
            st.update(ind);
        }

    }

}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
#ifdef _DEBUG
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif 

    solve();
}

