//#pragma GCC optimization ("O3")
//#pragma GCC optimization ("unroll-loops")

#include <bits/stdc++.h>
using namespace std;

int n, q; 
const int DIM = 100003;
int a[DIM]; 
int t[4*DIM];

void build (int v, int l, int r) {
    if (l==r) t[v] = a[l];
    else {
        int m = (l+r)/2;
        build(v*2+1, l, m);
        build(v*2+2, m+1, r);
        t[v] = __gcd(t[v*2+1], t[v*2+2]);
    }
    return;
}

void update (int v, int l, int r, int x, int val) {
    if (l>x || r<x) return;
    if (l==r) { t[v] = val; return; }
    
    int m = (l+r)/2;
    update(v*2+1, l, m, x, val);
    update(v*2+2, m+1, r, x, val);
    t[v] = __gcd(t[v*2+1], t[v*2+2]);
    return;
}

int gcd(int v, int l, int r, int i, int j) {
    if (l>j || r<i) return 0;
    if (l>=i && r<=j) { return t[v]; }
    int m = (l+r)/2;
    int gcd1 = gcd(v*2+1, l, m, i, j);
    int gcd2 = gcd(v*2+2, m+1, r, i, j);
    return __gcd(gcd1, gcd2);
}

vector <int> ch;

vector <int> changes (int l, int r) {
    vector <int> v;
    //cout<<"ch:"; for (int i=0; i<ch.size(); i++) cout<<ch[i]<<' '; cout<<"\n";
    sort(ch.begin(), ch.end());
    int l1 = lower_bound(ch.begin(), ch.end(), l) - ch.begin();
    int r1 = upper_bound(ch.begin(), ch.end(), r) - ch.begin();
    if (l1<ch.size())
        for (int i=l1; i<=r1; i++)
            v.push_back(ch[i]);
    //cout<<l<<' '<<r<<' '<<l1<<' '<<r1<<' '<<v.size()<<"\n";
    return v;
}


int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin>>n>>q;
    for (int i=0; i<n; i++) cin>>a[i];

    build(0, 0, n-1);

    int mem[n], memval[n];
    for (int i=0; i<n; i++) {
        mem[i]=-1;
        memval[i]=-1;
    }

    while (q--) {
        int type; cin>>type;
        if (type==1) {
            int x, v; cin>>x>>v; x--;
            a[x] = v; update(0, 0, n-1, x, v);
            ch.push_back(x);
        }
        else {
            int l, r; cin>>l>>r; l--; r--;
            int ans=0;
            for (int i=l; i<=r; i++)
            if ( mem[i]!=-1 && !(__gcd(a[i], memval[i])==1) ) {
                //cout<<i<<' '<<mem[i]<<' '<<memval[i]<<"\n";
                for (auto j : changes(i, mem[i])) {
                    if (__gcd(a[j], memval[i])>1) {
                        memval[i] = __gcd(memval[i], a[j]);
                        //continue;
                    }
                    else {
                        mem[i] = j-1;
                        //memval[i] = __gcd(memval[i], a[j-1])
                    }
                }
                ans+=mem[i]-i+1;
                
            } 
            else {
                int bsl=i, bsr=r;
                /**/
                int nsd;
                while (bsl!=bsr) {
                    int m = (bsl+bsr+1)/2;
                    nsd = gcd(0, 0, n-1, i, m);
                    if (nsd==1) bsr=m-1;
                    else bsl = m;
                }
                //cout<<i<<' '<<bsl<<"\n";
                nsd = gcd(0, 0, n-1, i, bsl);
                if ( nsd != 1) {
                    ans += bsl-i+1;
                    mem[i] = bsl; memval[i] = nsd;
                }
            }
            cout<<ans<<"\n";
        }
    }

}
